/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.requality.eclipse.core;

import java.util.List;
import java.util.Set;

import com.unitesk.requality.core.NodeDesc;
import com.unitesk.requality.core.TreeChangeListener;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.TreeNodeChangeEvent;

public class DefaultTreeChangeListener extends TreeChangeListener {
    @Override
    public void created(TreeNode node) {
    }

    @Override
    public void changed(TreeNode node, Set<String> what) {
    }

    @Override
    public void deleted(NodeDesc node) {
    }

    @Override
    public void moved(TreeNode node, TreeNode oldParent) {
    }

	@Override
	public void changed(List<TreeNodeChangeEvent> changes) {
		for(TreeNodeChangeEvent ce:changes)
			switch (ce.getType()) {
				case CREATE:
					created(ce.getTreeNodeTarget(),(Boolean)ce.getArguments()[0]);
					break;
				case DELETE:
					deleted(ce.getNodeDescTarget(),(Boolean)ce.getArguments()[0]);
					break;
				case CHANGE:
					changed(ce.getTreeNodeTarget(),(Set<String>)ce.getArguments()[1],(Boolean)ce.getArguments()[0]);
					break;
				case MOVE:
					moved(ce.getTreeNodeTarget(),(TreeNode)ce.getArguments()[1],(Boolean)ce.getArguments()[0]);
					break;
				default:
					break;
			}
	}

}
