package com.unitesk.requality.eclipse.storageformatversion;

import org.eclipse.core.resources.IProject;

/**
 * 
 * Interface for convertors of projects from old format of data store to new format  
 * @author kildishev
 *
 */

public interface IFormatVersionConverter {
	
	/**
	 * Method to convert project from one data storage scheme to another
	 * @param proj project to convert
	 * @return true is conversion was succeed, false otherwise 
	 */
	public boolean convert(IProject proj);
	/**
	 * Method to check of project to be suitable for current converter
	 * @param proj project to check 
	 * @return true if project is applicable for conversion
	 */
	public boolean isAppliable(IProject proj);
}
