package com.unitesk.requality.eclipse.views.properties;

import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

import com.unitesk.requality.core.CoreUtils;
import com.unitesk.requality.core.TreeNode;

public class NameEditPanel {
	private Text instancerName;
	private TreeNode node;
	private boolean transactionIgnore = false;
	public NameEditPanel(final Composite parent, int swt) {
		instancerName = new Text(parent, swt);
        instancerName.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
        instancerName.addFocusListener(new FocusAdapter() {
        	public void focusLost(FocusEvent e) {
        		if (!instancerName.getText().equals(instancerName.getText().trim())) {
                    instancerName.setText(instancerName.getText().trim());
                }
                if (node == null) {
                    return;
                }
                if (node.getName() == null && instancerName.getText().equals("") || 
                		node.getName() != null && 
                		node.getName().equals(instancerName.getText())) {
                    return;
                }
                if(transactionIgnore ||node.getTreeDB().startTransaction("Update "+CoreUtils.splitWords(node.getType()),true)){
                	node.setName(instancerName.getText());
                	node.saveAttributes();
                	if(!transactionIgnore)
                		node.getTreeDB().commit();
                }else
                	instancerName.setText(node.getName()!=null?node.getName():"");
            }
        });
	}
	public void setTreeNode(TreeNode nde){
		node = nde;
		if(nde!=null){
			String s = nde.getName();
			instancerName.setText(nde.getName()==null?"":s);
		}
		else
			instancerName.setText("");
	}
	public Text getControl() {
		return instancerName;
	}
	public void setTransactionIgnore(boolean transactionIgnore) {
		this.transactionIgnore = transactionIgnore;
	}

	
}
