package com.unitesk.requality.eclipse.wizards;

import java.io.ByteArrayInputStream;
import java.io.UnsupportedEncodingException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.dialogs.DialogSettings;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IExportWizard;
import org.eclipse.ui.IWorkbench;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.core.TreesTracker;
import com.unitesk.requality.tools.ReqIFConverter;

public class ExportToReqIFWizard extends Wizard implements IExportWizard {

	private IStructuredSelection selection;
	private TreeDB db;
	private  NewFilePage fp;

	public ExportToReqIFWizard() {
		super();
	}
	
	@Override
	public void addPages() {
    	TreeDB db = getSelectedTreeDB();
        StructuredSelection sel;
        if(db != null)
        	sel = new StructuredSelection(db);
        else
        	sel = new StructuredSelection();
        fp = new NewFilePage(sel,"");
        addPage(fp);
        fp.setDescription("Сhoose target project and select file name");
	};
	private TreeDB getSelectedTreeDB() {
    	if(!(selection instanceof StructuredSelection))
    		return db;
    	TreeDB db = this.db;
    	Object o = ((StructuredSelection)selection).getFirstElement();
    	if(o instanceof IProject)
    		db = TreesTracker.getTracker().getTree((IProject)o);
    	if(o instanceof TreeNode)
    		db = ((TreeNode)o).getTreeDB();
    	if(o instanceof TreeDB)
    		db = (TreeDB)o;
    	this.db = db;
    	return db;
	}
	@Override
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		setWindowTitle("Requality to ReqIF export wizard");
        this.selection = selection;
	}

	@Override
	public boolean performFinish() {
		try {
			IFile f = fp.createNewFile();
			f.setCharset("UTF-8",null);
			try {
				f.setContents(new ByteArrayInputStream(ReqIFConverter.convertCatalogToText(db).getBytes("UTF-8")), 0, null);
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
		} catch (CoreException e) {
			e.printStackTrace();
		}
		return true;
	}

}
